package internal

import (
	"net/http"
	"time"

	"gitea.dwysokinski.me/twhelp/core/internal/adapter"
	"gitea.dwysokinski.me/twhelp/core/internal/tw"
)

const (
	twClientTimeout = 10 * time.Second
)

func NewTWClient(version string) *adapter.TWHTTPClient {
	return adapter.NewTWHTTPClient(
		tw.NewClient(
			tw.WithHTTPClient(&http.Client{
				Timeout: twClientTimeout,
			}),
			tw.WithUserAgent("tribalwarshelp/"+version),
		),
	)
}
