package adapter

import (
	"context"

	"github.com/uptrace/bun"
)

type BunChecker struct {
	db *bun.DB
}

func NewBunChecker(db *bun.DB) *BunChecker {
	return &BunChecker{db: db}
}

func (c *BunChecker) Name() string {
	return "db:ping"
}

func (c *BunChecker) Check(ctx context.Context) error {
	return c.db.PingContext(ctx)
}
