package bunmodel_test

import (
	"testing"

	"gitea.dwysokinski.me/twhelp/core/internal/adapter/internal/bunmodel"
	"gitea.dwysokinski.me/twhelp/core/internal/domain"
	"github.com/stretchr/testify/assert"
)

func TestBuildingInfo(t *testing.T) {
	t.Parallel()

	info := domain.BuildingInfo{
		Main: domain.Building{
			MaxLevel: 124,
			Wood:     12224,
		},
		Barracks: domain.Building{
			MinLevel: 22,
			Stone:    12341,
		},
		Stable: domain.Building{
			Wood: 22241,
			Pop:  111,
		},
		Garage: domain.Building{
			Stone:      11121,
			WoodFactor: 0.99,
		},
		Watchtower: domain.Building{
			Iron:        123412,
			StoneFactor: 0.878,
		},
		Snob: domain.Building{
			Pop:       789,
			PopFactor: 0.11,
		},
		Smith: domain.Building{
			BuildTime:       23.49999,
			BuildTimeFactor: 0.999,
		},
		Place: domain.Building{
			MaxLevel: 112,
		},
		Statue: domain.Building{
			MinLevel: 123,
		},
		Market: domain.Building{
			Pop: 1234,
		},
		Wood: domain.Building{
			WoodFactor: 0.998,
		},
		Stone: domain.Building{
			StoneFactor: 0.777,
		},
		Iron: domain.Building{
			IronFactor: 0.5689,
		},
		Farm: domain.Building{
			PopFactor: 0.9,
		},
		Storage: domain.Building{
			MaxLevel: 31,
		},
		Hide: domain.Building{
			MinLevel: 1,
		},
		Wall: domain.Building{
			MaxLevel:        20,
			MinLevel:        0,
			Wood:            1234,
			Stone:           1231,
			Iron:            3214,
			Pop:             1,
			WoodFactor:      0.999,
			StoneFactor:     0.998,
			IronFactor:      0.977,
			PopFactor:       2,
			BuildTime:       30.5,
			BuildTimeFactor: 0.5,
		},
	}
	assert.Equal(t, info, bunmodel.NewBuildingInfo(info).ToDomain())
}
