package bunmodel

import "gitea.dwysokinski.me/twhelp/core/internal/domain"

type Unit struct {
	BuildTime      float64
	Pop            int16
	Speed          float64
	Attack         int16
	Defense        int16
	DefenseCavalry int16
	DefenseArcher  int16
	Carry          int16
}

type UnitInfo struct {
	Spear    Unit
	Sword    Unit
	Axe      Unit
	Archer   Unit
	Spy      Unit
	Light    Unit
	Marcher  Unit
	Heavy    Unit
	Ram      Unit
	Catapult Unit
	Knight   Unit
	Snob     Unit
	Militia  Unit
}

func NewUnitInfo(info domain.UnitInfo) UnitInfo {
	return UnitInfo{
		Spear:    Unit(info.Spear),
		Sword:    Unit(info.Sword),
		Axe:      Unit(info.Axe),
		Archer:   Unit(info.Archer),
		Spy:      Unit(info.Spy),
		Light:    Unit(info.Light),
		Marcher:  Unit(info.Marcher),
		Heavy:    Unit(info.Heavy),
		Ram:      Unit(info.Ram),
		Catapult: Unit(info.Catapult),
		Knight:   Unit(info.Knight),
		Snob:     Unit(info.Snob),
		Militia:  Unit(info.Militia),
	}
}

func (u UnitInfo) ToDomain() domain.UnitInfo {
	return domain.UnitInfo{
		Spear:    domain.Unit(u.Spear),
		Sword:    domain.Unit(u.Sword),
		Axe:      domain.Unit(u.Axe),
		Archer:   domain.Unit(u.Archer),
		Spy:      domain.Unit(u.Spy),
		Light:    domain.Unit(u.Light),
		Marcher:  domain.Unit(u.Marcher),
		Heavy:    domain.Unit(u.Heavy),
		Ram:      domain.Unit(u.Ram),
		Catapult: domain.Unit(u.Catapult),
		Knight:   domain.Unit(u.Knight),
		Snob:     domain.Unit(u.Snob),
		Militia:  domain.Unit(u.Militia),
	}
}
