package bunmodel_test

import (
	"testing"

	"gitea.dwysokinski.me/twhelp/core/internal/adapter/internal/bunmodel"
	"gitea.dwysokinski.me/twhelp/core/internal/domain"
	"github.com/stretchr/testify/assert"
)

func TestUnitInfo(t *testing.T) {
	t.Parallel()

	info := domain.UnitInfo{
		Spear: domain.Unit{
			BuildTime: 5.8777,
		},
		Sword: domain.Unit{
			Pop: 1,
		},
		Axe: domain.Unit{
			Speed: 13.7777,
		},
		Archer: domain.Unit{
			Attack: 10,
		},
		Spy: domain.Unit{
			Defense: 1,
		},
		Light: domain.Unit{
			DefenseCavalry: 15,
		},
		Marcher: domain.Unit{
			DefenseArcher: 10,
		},
		Heavy: domain.Unit{
			BuildTime: 30.1234,
			Pop:       6,
		},
		Ram: domain.Unit{
			Speed:  30.849,
			Attack: 1,
		},
		Catapult: domain.Unit{
			Defense:        12,
			DefenseCavalry: 123,
		},
		Knight: domain.Unit{
			DefenseArcher: 1234,
			Carry:         10,
		},
		Snob: domain.Unit{
			BuildTime: 1234.4,
			Pop:       100,
			Speed:     35,
		},
		Militia: domain.Unit{
			BuildTime:      1,
			Pop:            2,
			Speed:          3,
			Attack:         4,
			Defense:        5,
			DefenseCavalry: 6,
			DefenseArcher:  7,
			Carry:          8,
		},
	}
	assert.Equal(t, info, bunmodel.NewUnitInfo(info).ToDomain())
}
