package bunmodel

import (
	"gitea.dwysokinski.me/twhelp/core/internal/domain"
	"github.com/uptrace/bun"
)

type Version struct {
	bun.BaseModel `bun:"table:versions,alias:version"`

	Code     string `bun:"code,pk,nullzero"`
	Name     string `bun:"name,nullzero"`
	Host     string `bun:"host,nullzero"`
	Timezone string `bun:"timezone,nullzero"`
}

func (v Version) ToDomain() domain.Version {
	return domain.Version{
		Code:     v.Code,
		Name:     v.Name,
		Host:     v.Host,
		Timezone: v.Timezone,
	}
}
