package bunmodel_test

import (
	"testing"

	"github.com/stretchr/testify/assert"

	"gitea.dwysokinski.me/twhelp/core/internal/adapter/internal/bunmodel"
	"gitea.dwysokinski.me/twhelp/core/internal/domain"
)

func TestVersion_ToDomain(t *testing.T) {
	t.Parallel()

	domainModel := domain.Version{
		Code:     "pl",
		Name:     "Poland",
		Host:     "plemiona.pl",
		Timezone: "Europe/Warsaw",
	}
	dbModel := bunmodel.Version{
		Code:     domainModel.Code,
		Name:     domainModel.Name,
		Host:     domainModel.Host,
		Timezone: domainModel.Timezone,
	}
	assert.Equal(t, domainModel, dbModel.ToDomain())
}
