package domain

type Building struct {
	MaxLevel        int8
	MinLevel        int8
	Wood            int32
	Stone           int32
	Iron            int32
	Pop             int16
	WoodFactor      float64
	StoneFactor     float64
	IronFactor      float64
	PopFactor       float64
	BuildTime       float64
	BuildTimeFactor float64
}

type BuildingInfo struct {
	Main       Building
	Barracks   Building
	Stable     Building
	Garage     Building
	Watchtower Building
	Snob       Building
	Smith      Building
	Place      Building
	Statue     Building
	Market     Building
	Wood       Building
	Stone      Building
	Iron       Building
	Farm       Building
	Storage    Building
	Hide       Building
	Wall       Building
}

type NullBuildingInfo struct {
	Info  BuildingInfo
	Valid bool // Valid is true if Info is not NULL
}
