package domain

import "fmt"

type Version struct {
	Code     string
	Name     string
	Host     string
	Timezone string
}

func (v Version) URL() string {
	return "https://" + v.Host
}

type VersionNotFoundError struct {
	VerCode string
}

func (e VersionNotFoundError) Error() string {
	return fmt.Sprintf("version (code=%s) not found", e.VerCode)
}

func (e VersionNotFoundError) UserError() string {
	return e.Error()
}

func (e VersionNotFoundError) Code() ErrorCode {
	return ErrorCodeEntityNotFound
}
