package model

import (
	"errors"
	"time"
)

const (
	dateFormat = "2006-01-02"
)

type Date struct {
	time.Time
}

func (d Date) MarshalJSON() ([]byte, error) {
	b := make([]byte, 0, len(dateFormat)+len(`""`))
	b = append(b, '"')
	b = d.AppendFormat(b, dateFormat)
	b = append(b, '"')
	return b, nil
}

func (d *Date) UnmarshalJSON(data []byte) error {
	if len(data) < 2 || data[0] != '"' || data[len(data)-1] != '"' {
		return errors.New("Date.UnmarshalJSON: input is not a JSON string")
	}
	var err error
	d.Time, err = time.Parse(dateFormat, string(data[len(`"`):len(data)-len(`"`)]))
	if err != nil {
		return err
	}
	return nil
}
