package model

import "gitea.dwysokinski.me/twhelp/core/internal/domain"

type ServerConfigBuild struct {
	Destroy int8 `json:"destroy"`
} // @name ServerConfigBuild

type ServerConfigMisc struct {
	KillRanking     int8  `json:"killRanking"`
	Tutorial        int8  `json:"tutorial"`
	TradeCancelTime int16 `json:"tradeCancelTime"`
} // @name ServerConfigMisc

type ServerConfigCommands struct {
	MillisArrival     int16 `json:"millisArrival"`
	CommandCancelTime int16 `json:"commandCancelTime"`
} // @name ServerConfigCommands

type ServerConfigNewbie struct {
	Days                 int16 `json:"days"`
	RatioDays            int16 `json:"ratioDays"`
	Ratio                int16 `json:"ratio"`
	RemoveNewbieVillages int8  `json:"removeNewbieVillages"`
} // @name ServerConfigNewbie

type ServerConfigGame struct {
	BuildtimeFormula   int8    `json:"buildtimeFormula"`
	Knight             int8    `json:"knight"`
	KnightNewItems     int8    `json:"knightNewItems"`
	Archer             int8    `json:"archer"`
	Tech               int8    `json:"tech"`
	FarmLimit          int32   `json:"farmLimit"`
	Church             int8    `json:"church"`
	Watchtower         int8    `json:"watchtower"`
	Stronghold         int8    `json:"stronghold"`
	FakeLimit          float64 `json:"fakeLimit"`
	BarbarianRise      float64 `json:"barbarianRise"`
	BarbarianShrink    int8    `json:"barbarianShrink"`
	BarbarianMaxPoints int32   `json:"barbarianMaxPoints"`
	Scavenging         int8    `json:"scavenging"`
	Hauls              int8    `json:"hauls"`
	HaulsBase          int32   `json:"haulsBase"`
	HaulsMax           int32   `json:"haulsMax"`
	BaseProduction     int32   `json:"baseProduction"`
	Event              int16   `json:"event"`
	SuppressEvents     int8    `json:"suppressEvents"`
} // @name ServerConfigGame

type ServerConfigBuildings struct {
	CustomMain       int8 `json:"customMain"`
	CustomFarm       int8 `json:"customFarm"`
	CustomStorage    int8 `json:"customStorage"`
	CustomPlace      int8 `json:"customPlace"`
	CustomBarracks   int8 `json:"customBarracks"`
	CustomChurch     int8 `json:"customChurch"`
	CustomSmith      int8 `json:"customSmith"`
	CustomWood       int8 `json:"customWood"`
	CustomStone      int8 `json:"customStone"`
	CustomIron       int8 `json:"customIron"`
	CustomMarket     int8 `json:"customMarket"`
	CustomStable     int8 `json:"customStable"`
	CustomWall       int8 `json:"customWall"`
	CustomGarage     int8 `json:"customGarage"`
	CustomHide       int8 `json:"customHide"`
	CustomSnob       int8 `json:"customSnob"`
	CustomStatue     int8 `json:"customStatue"`
	CustomWatchtower int8 `json:"customWatchtower"`
} // @name ServerConfigBuildings

type ServerConfigSnob struct {
	Gold          int8    `json:"gold"`
	CheapRebuild  int8    `json:"cheapRebuild"`
	Rise          int8    `json:"rise"`
	MaxDist       int16   `json:"maxDist"`
	Factor        float64 `json:"factor"`
	CoinWood      int32   `json:"coinWood"`
	CoinStone     int32   `json:"coinStone"`
	CoinIron      int32   `json:"coinIron"`
	NoBarbConquer int8    `json:"noBarbConquer"`
} // @name ServerConfigSnob

type ServerConfigAlly struct {
	NoHarm                int8   `json:"noHarm"`
	NoOtherSupport        int8   `json:"noOtherSupport"`
	NoOtherSupportType    int8   `json:"noOtherSupportType"`
	AllytimeSupport       int32  `json:"allytimeSupport"`
	NoLeave               int8   `json:"noLeave"`
	NoJoin                int8   `json:"noJoin"`
	Limit                 int16  `json:"limit"`
	FixedAllies           int8   `json:"fixedAllies"`
	PointsMemberCount     int32  `json:"pointsMemberCount"`
	WarsMemberRequirement int16  `json:"warsMemberRequirement"`
	WarsPointsRequirement int32  `json:"warsPointsRequirement"`
	WarsAutoacceptDays    int16  `json:"warsAutoacceptDays"`
	Levels                int8   `json:"levels"`
	XpRequirements        string `json:"xpRequirements"`
} // @name ServerConfigAlly

type ServerConfigCoord struct {
	MapSize         int16 `json:"mapSize"`
	Func            int8  `json:"func"`
	EmptyVillages   int16 `json:"emptyVillages"`
	BonusVillages   int16 `json:"bonusVillages"`
	BonusNew        int16 `json:"bonusNew"`
	Inner           int32 `json:"inner"`
	SelectStart     int8  `json:"selectStart"`
	VillageMoveWait int32 `json:"villageMoveWait"`
	NobleRestart    int8  `json:"nobleRestart"`
	StartVillages   int8  `json:"startVillages"`
} // @name ServerConfigCoord

type ServerConfigSitter struct {
	Allow int8 `json:"allow"`
} // @name ServerConfigSitter

type ServerConfigSleep struct {
	Active   int8  `json:"active"`
	Delay    int32 `json:"delay"`
	Min      int16 `json:"min"`
	Max      int16 `json:"max"`
	MinAwake int16 `json:"minAwake"`
	MaxAwake int16 `json:"maxAwake"`
	WarnTime int16 `json:"warnTime"`
} // @name ServerConfigSleep

type ServerConfigNight struct {
	Active    int8    `json:"active"`
	StartHour int8    `json:"startHour"`
	EndHour   int8    `json:"endHour"`
	DefFactor float64 `json:"defFactor"`
	Duration  int8    `json:"duration"`
} // @name ServerConfigNight

type ServerConfigWin struct {
	Check int16 `json:"check"`
} // @name ServerConfigWin

type ServerConfig struct {
	Speed     float64               `json:"speed"`
	UnitSpeed float64               `json:"unitSpeed"`
	Moral     int16                 `json:"moral"`
	Build     ServerConfigBuild     `json:"build"`
	Misc      ServerConfigMisc      `json:"misc"`
	Commands  ServerConfigCommands  `json:"commands"`
	Newbie    ServerConfigNewbie    `json:"newbie"`
	Game      ServerConfigGame      `json:"game"`
	Buildings ServerConfigBuildings `json:"buildings"`
	Snob      ServerConfigSnob      `json:"snob"`
	Ally      ServerConfigAlly      `json:"ally"`
	Coord     ServerConfigCoord     `json:"coord"`
	Sitter    ServerConfigSitter    `json:"sitter"`
	Sleep     ServerConfigSleep     `json:"sleep"`
	Night     ServerConfigNight     `json:"night"`
	Win       ServerConfigWin       `json:"win"`
} // @name ServerConfig

func NewServerConfig(cfg domain.ServerConfig) ServerConfig {
	return ServerConfig{
		Speed:     cfg.Speed,
		UnitSpeed: cfg.UnitSpeed,
		Moral:     cfg.Moral,
		Build:     ServerConfigBuild(cfg.Build),
		Misc:      ServerConfigMisc(cfg.Misc),
		Commands:  ServerConfigCommands(cfg.Commands),
		Newbie:    ServerConfigNewbie(cfg.Newbie),
		Game:      ServerConfigGame(cfg.Game),
		Buildings: ServerConfigBuildings(cfg.Buildings),
		Snob:      ServerConfigSnob(cfg.Snob),
		Ally:      ServerConfigAlly(cfg.Ally),
		Coord:     ServerConfigCoord(cfg.Coord),
		Sitter:    ServerConfigSitter(cfg.Sitter),
		Sleep:     ServerConfigSleep(cfg.Sleep),
		Night:     ServerConfigNight(cfg.Night),
		Win:       ServerConfigWin(cfg.Win),
	}
}

type GetServerConfigResp struct {
	Data ServerConfig `json:"data"`
} // @name GetServerConfigResp

func NewGetServerConfigResp(cfg domain.ServerConfig) GetServerConfigResp {
	return GetServerConfigResp{
		Data: NewServerConfig(cfg),
	}
}
