package model

import "gitea.dwysokinski.me/twhelp/core/internal/domain"

type Unit struct {
	BuildTime      float64 `json:"buildTime"`
	Pop            int16   `json:"pop"`
	Speed          float64 `json:"speed"`
	Attack         int16   `json:"attack"`
	Defense        int16   `json:"defense"`
	DefenseCavalry int16   `json:"defenseCavalry"`
	DefenseArcher  int16   `json:"defenseArcher"`
	Carry          int16   `json:"carry"`
} // @name Unit

type UnitInfo struct {
	Spear    Unit `json:"spear"`
	Sword    Unit `json:"sword"`
	Axe      Unit `json:"axe"`
	Archer   Unit `json:"archer"`
	Spy      Unit `json:"spy"`
	Light    Unit `json:"light"`
	Marcher  Unit `json:"marcher"`
	Heavy    Unit `json:"heavy"`
	Ram      Unit `json:"ram"`
	Catapult Unit `json:"catapult"`
	Knight   Unit `json:"knight"`
	Snob     Unit `json:"snob"`
	Militia  Unit `json:"militia"`
} // @name UnitInfo

func NewUnitInfo(info domain.UnitInfo) UnitInfo {
	return UnitInfo{
		Spear:    Unit(info.Spear),
		Sword:    Unit(info.Sword),
		Axe:      Unit(info.Axe),
		Archer:   Unit(info.Archer),
		Spy:      Unit(info.Spy),
		Light:    Unit(info.Light),
		Marcher:  Unit(info.Marcher),
		Heavy:    Unit(info.Heavy),
		Ram:      Unit(info.Ram),
		Catapult: Unit(info.Catapult),
		Knight:   Unit(info.Knight),
		Snob:     Unit(info.Snob),
		Militia:  Unit(info.Militia),
	}
}

type GetUnitInfoResp struct {
	Data UnitInfo `json:"data"`
} // @name GetUnitInfoResp

func NewGetUnitInfoResp(cfg domain.UnitInfo) GetUnitInfoResp {
	return GetUnitInfoResp{
		Data: NewUnitInfo(cfg),
	}
}
