package model

import "gitea.dwysokinski.me/twhelp/core/internal/domain"

type Version struct {
	Code     string `json:"code" example:"pl"`
	Name     string `json:"name" example:"Poland"`
	Host     string `json:"host" example:"plemiona.pl"`
	Timezone string `json:"timezone" example:"Europe/Warsaw"`
} // @name Version

func NewVersion(v domain.Version) Version {
	return Version{
		Code:     v.Code,
		Name:     v.Name,
		Host:     v.Host,
		Timezone: v.Timezone,
	}
}

type ListVersionsResp struct {
	Data []Version `json:"data"`
} // @name ListVersionsResp

func NewListVersionsResp(versions []domain.Version) ListVersionsResp {
	resp := ListVersionsResp{
		Data: make([]Version, 0, len(versions)),
	}
	for _, v := range versions {
		resp.Data = append(resp.Data, NewVersion(v))
	}
	return resp
}

type GetVersionResp struct {
	Data Version `json:"data"`
} // @name GetVersionResp

func NewGetVersionResp(v domain.Version) GetVersionResp {
	return GetVersionResp{
		Data: NewVersion(v),
	}
}
