package tw_test

import (
	"errors"
	"fmt"
	"testing"

	"gitea.dwysokinski.me/twhelp/core/internal/tw"
	"github.com/stretchr/testify/assert"
)

func TestParseError(t *testing.T) {
	t.Parallel()

	err := tw.ParseError{
		Field: "test",
		Str:   "anything",
		Err:   errors.New("err"),
	}
	assert.Equal(t, fmt.Sprintf("%s: parsing \"%s\": %s", err.Field, err.Str, err.Err.Error()), err.Error())
	assert.ErrorIs(t, err, err.Err)
}
